import styles  from './index.less';
import { useEffect } from 'react';
import Box from '@/component/box';
import { connect } from 'dva';

function Main({ dispatch, list,nowFlage,num,actionData,gameStatus,winer }) {


  useEffect(()=>{
    if(!gameStatus) return
    let twoDArry = renderArry(list)
    if(!twoDArry) return
    let reData = checkWin(twoDArry)
    if(reData && reData.status==='win') {
      dispatch({
        type:"main/updateWinerFn",
        winer:reData.winer
      })
    }

  })

  // 组装二维数组
  function renderArry(dataList) {
    var tempArry=[]
    let len = dataList.length
    let n = 3; //假设每行显示3个
    let lineNum = len % 3 === 0 ? len / 3 : Math.floor( (len / 3) + 1 );
    for(let i=0;i<lineNum;i++) {
      let temp = dataList.slice(i*n, i*n+n);
      tempArry.push(temp);
    }
    return tempArry
  }
  // 判断输赢
  function checkWin(twoDArry) {
   // 判断第一行
      if(twoDArry[0][0].flage !=null && twoDArry[0][1].flage !=null && twoDArry[0][2].flage !=null && twoDArry[0][0].flage === twoDArry[0][1].flage && twoDArry[0][1].flage === twoDArry[0][2].flage) {
        return {status:'win',winer:twoDArry[0][0]}
      }
    // 判断第二行
      if(twoDArry[1][0].flage !=null &&  twoDArry[1][1].flage !=null && twoDArry[1][2].flage !=null && twoDArry[1][0].flage === twoDArry[1][1].flage && twoDArry[1][1].flage === twoDArry[1][2].flage) {
        return {status:'win',winer:twoDArry[1][0]}
      }
    // 判断第三行
      if(twoDArry[2][0].flage !=null && twoDArry[2][1].flage !=null && twoDArry[2][2].flage !=null && twoDArry[2][0].flage === twoDArry[2][1].flage && twoDArry[2][1].flage === twoDArry[2][2].flage) {
        return {status:'win',winer:twoDArry[2][0]}
      }
    // 判断第一列
      if(twoDArry[0][0].flage !=null && twoDArry[1][0].flage !=null && twoDArry[2][0].flage !=null && twoDArry[0][0].flage === twoDArry[1][0].flage && twoDArry[1][0].flage === twoDArry[2][0].flage) {
        return {status:'win',winer:twoDArry[0][0]}
      }
    // 判断第二列
      if(twoDArry[0][1].flage !=null && twoDArry[1][1].flage !=null && twoDArry[2][1].flage !=null && twoDArry[0][1].flage === twoDArry[1][1].flage && twoDArry[1][1].flage === twoDArry[2][1].flage) {
        return {status:'win',winer:twoDArry[0][1]}
      }
    // 判断第三列
      if(twoDArry[0][2].flage !=null && twoDArry[1][2].flage !=null && twoDArry[2][2].flage !=null && twoDArry[0][2].flage === twoDArry[1][2].flage && twoDArry[1][2].flage === twoDArry[2][2].flage) {
        return {status:'win',winer:twoDArry[0][2]}
      }
    // 判断交叉左上角到右下角
      if(twoDArry[0][0].flage !=null && twoDArry[1][1].flage !=null && twoDArry[2][2].flage !=null && twoDArry[0][0].flage === twoDArry[1][1].flage && twoDArry[1][1].flage === twoDArry[2][2].flage) {
        return {status:'win',winer:twoDArry[0][0]}
      }
    // 判断交叉右上角到左下角
      if(twoDArry[0][2].flage !=null && twoDArry[1][1].flage !=null && twoDArry[2][0].flage !=null && twoDArry[0][2].flage === twoDArry[1][1].flage && twoDArry[1][1].flage === twoDArry[2][0].flage) {
        return {status:'win',winer:twoDArry[0][2]}
      }
  }


  function handleChangeData(flage,key,actionData,list) {
    dispatch({
      type:'main/updateWinerFn',
      winer:null
    })
    dispatch({
      type:'main/updateRenderDataFn',
      key:key,
      actionData:actionData,
      flage:flage,
      list:list
    })
  }

  return (
    <div>
    <div className={styles.content}>
      {
        list.map((item,index)=>{
          return (
            <Box
              key={item.value}
              value={item.value}
              nowFliage={nowFlage}
              dispatch={dispatch}
              datasource={list}
              flage={item.flage}
              num={num}
              actionData={actionData}
              winer={winer}
            />
          )
        })
      }
    </div>
    <div className={styles.rightBox}>
        <p>Next player: {nowFlage} </p>
      {
        winer ? <p>Winer is {winer.flage}</p> : ""
      }
      <ul>
        <li>
          <button onClick={()=>handleChangeData(true,false,false,list)}> Go to Game Start</button>
        </li>
        {
          actionData.map((item,index)=>{
            return  (
              <li key={item.key} value={item.key} >
                <button className={styles.numLi} onClick={()=>handleChangeData(false,item.key,actionData,list)}> Go to move #{item.key}</button>
              </li>
            )
          })
        }
      </ul>
    </div>
    </div>
  );
}

function mapStateToProps(state) {
  const { nowFlage,list,num,actionData,gameStatus,winer } = state.main;
  return {
    nowFlage,
    list,
    num,
    actionData,
    gameStatus,
    winer
  };
}

export default connect(mapStateToProps)(Main);
